import urllib, json, unicodedata, time

#This script uses the free Google Maps geocoding service, allowing for geocoding up to 2,500 addresses per day.
#Setup:  1)Save this script into the same folder your input addresses are in.
#        2)Format your input addresses into a tab-delimited text file without headers.
#        3)Change "geocoding_input.txt" below to the name of your input file name.
inputfile = r".\geocoding_input.txt"
#        4)Open a command prompt, and change directories into the folder where this file is.  At the command
#        prompt, type in:  google_geocoding_free.py  The script will run, geocoding each input address, and
#        outputting the results into a file named "geocoding_output.txt".
#        Updated by Jeff Blossom, 5/23/2016
outputfile = r".\geocoding_output.txt"

url = "http://maps.googleapis.com/maps/api/geocode/json"
channel = ""

field1 = "ID"
field2 = "In_Address"
field3 = "In_City"
field4 = "In_State"
field5 = "In_Country"
field6 = "Address_Matched"
field7 = "City_Matched"
field8 = "State_Matched"
field9 = "Country_Matched"
field10 = "Location_Type"
field11 = "Latitude"
field12 = "Longitude"

f_in = open(inputfile, 'r')
f_out = open(outputfile, 'w')
f_out.write("%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\n" % (field1, field2, field3, field4, field5, field6, field7, field8, field9, field10, field11, field12))
for line in f_in:
   fields = line.strip().replace("\"", "").split('\t')
   address = "%s+%s,%s,%s" % (fields[2], fields[1], fields[3], fields[4])
   address = unicodedata.normalize('NFKD', address.decode("utf-8", "replace")).encode('ascii', 'ignore')
   address = address.replace("n/a", "").replace(" ", "+")
   data = urllib.urlopen("%s?address=%s&sensor=false" % (url, address))
   data_json = json.loads(data.read())
   city_name = "N/A"
   admin1 = "N/A"
   country = "N/A"
   streetNum = "N/A"
   street = "N/A"
   for i in range(len(data_json["results"])):
      for component in data_json["results"][i]["address_components"]:
         if "locality" in component["types"]:
            city_name = component["long_name"]
      if city_name != "N/A":
         break
   for i in range(len(data_json["results"])):
      for component in data_json["results"][i]["address_components"]:
         if "administrative_area_level_1" in component["types"]:
            admin1 = component["long_name"]
      if admin1 != "N/A":
         break
   for i in range(len(data_json["results"])):
      for component in data_json["results"][i]["address_components"]:
         if "country" in component["types"]:
            country = component["long_name"]
      if country != "N/A":
         break
   for i in range(len(data_json["results"])):
      for component in data_json["results"][i]["address_components"]:
         if "street_number" in component["types"]:
            streetNum = component["long_name"]
      if streetNum != "N/A":
         break
   for i in range(len(data_json["results"])):
      for component in data_json["results"][i]["address_components"]:
         if "route" in component["types"]:
            street = component["long_name"]
      if street != "N/A":
         break
   p_city = unicodedata.normalize('NFKD', unicode(city_name)).encode('ascii', 'ignore')
   p_admin1 = unicodedata.normalize('NFKD', unicode(admin1)).encode('ascii', 'ignore')
   p_country = unicodedata.normalize('NFKD', unicode(country)).encode('ascii', 'ignore')
   p_address = unicodedata.normalize('NFKD', unicode(streetNum)).encode('ascii', 'ignore') + " " + unicodedata.normalize('NFKD', unicode(street)).encode('ascii', 'ignore')
   print("Processed" + "  " + fields[0] + "  " +  p_address + "  " +  p_city)
 
   try:
      f_out.write("%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\n" % (fields[0], fields[1], fields[2], fields[3], fields[4], p_address, p_city, p_admin1 , p_country, data_json["results"][0]["geometry"]["location_type"], data_json["results"][0]["geometry"]["location"]["lat"], data_json["results"][0]["geometry"]["location"]["lng"]))
   #except: continue
   except: f_out.write("%s\t%s\t%s\t%s\t%s\t%s\n" % (fields[0], fields[1], fields[2], fields[3], fields[4], "not found"))
   time.sleep(.5)
   #print data.read()

print "finished"
f_out.flush()
f_in.close()
f_out.close()
